// -------- MARTIN PELIKAN ----------- //
// sztorkie@centrum.cz //
// kategorie starsi zaci //
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp, StdCtrls, ExtCtrls, StrUtils;

type
  TForm1 = class(TForm)
    edtAddress: TEdit;
    edtPort: TEdit;
    btnConnect: TButton;
    ClientSocket1: TClientSocket;
    btnDisConnect: TButton;
    lblAddress: TLabel;
    lblPort: TLabel;
    edtPosliPrikaz: TEdit;
    lblPosliPrikaz: TLabel;
    btnPosliPrikaz: TButton;
    btnEnd: TButton;
    memoUdalosti: TMemo;
    btnDelMemo: TButton;
    edtTextInfo: TEdit;
    btnNastav: TButton;
    procedure btnConnectClick(Sender: TObject);
    procedure btnDisConnectClick(Sender: TObject);
    procedure btnPosliPrikazClick(Sender: TObject);
    procedure btnEndClick(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure btnDelMemoClick(Sender: TObject);
    procedure btnNastavClick(Sender: TObject);
    procedure Posli(co:string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnConnectClick(Sender: TObject);
begin
try
 try // zkousime, jestli uzivatel zadal spravne adresu a port
  ClientSocket1.Address := edtAddress.text;
  ClientSocket1.Port := StrToInt(edtPort.text);
  except
   on EConvertError do ShowMessage('Chyba pri konverzi. Zadejte vse ve spravnem formatu.');
  end;
 finally // a potom se pokusime pripojit
  try
   ClientSocket1.Open; // navazeme spojeni se serverem
  except // a osetrime chybu, kdyby nahodou nebezel server
   on ESocketError do ShowMessage('Chyba pri pripojovani - blbne sit a nebo neni server spusten.');
  end;
end;
end;

procedure TForm1.Posli(co:string);
begin
ClientSocket1.Socket.SendText(co + #13 + #10);  // procedura na ulehceni posilani dat pridava na konec i znaky konce radku
end;

procedure TForm1.btnDisConnectClick(Sender: TObject);
begin
ClientSocket1.Close;  // rusime spojeni
end;

procedure TForm1.btnPosliPrikazClick(Sender: TObject);
begin
Posli(edtPosliPrikaz.text); // posleme
end;

procedure TForm1.btnEndClick(Sender: TObject);
begin
Application.Terminate;  // koncime
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var zprava: string; // prave prichozi zprava
patro: integer;
// BUDE SE MUSET ZJISTOVAT POKAZDE ZVLAST, ABY NEDOCHAZELO K CHYBAM - NEKDE TO NENI NUTNE
begin
zprava := ClientSocket1.Socket.ReceiveText;
memoUdalosti.Lines.Add(zprava); // prijmeme a zapiseme

// -------------------------------------------------------- LEVELBUTTON UP/DN

if LeftStr(zprava,13) = 'levelbuttonup' then
 begin
 patro := StrToInt(LeftStr(RightStr(zprava,4),2)); // odfiltrujeme dva znaky konce radku a nechame si jen cislo
 Posli('indiupon ' + IntToStr(patro));  //rozsvitime kontrolku
 Posli('floor 0 '+ IntToStr(patro));   // jedeme tam, kam chceme
 Posli('open 0');  // a potom je zase otevreme
 Posli('close 0');  // pomaha to udelat takhle...
 Posli('open 0');
 end;
if LeftStr(zprava,13) = 'levelbuttondn' then
 begin
 patro := StrToInt(LeftStr(RightStr(zprava,4),2)); // odfiltrujeme dva znaky konce radku a nechame si jen cislo
 Posli('indidnon ' + IntToStr(patro));  //rozsvitime kontrolku
 Posli('floor 0 '+ IntToStr(patro));
 Posli('open 0');  // a potom je zase otevreme
 Posli('close 0');  // pomaha to udelat takhle...
 Posli('open 0');
 end;

// -------------------------------------------------------- CABINBUTTON

if LeftStr(zprava, 11) = 'cabinbutton' then
 begin
 // zjistime si cislo patra, kam chce blazen jet
 patro := StrToInt(LeftStr(RightStr(zprava,4),2)); // odfiltrujeme dva znaky konce radku a nechame si jen cislo
 Posli('floor 0 ' + IntToStr(patro)); // a posleme ho tam, kde slunce nesviti (patro, kam chtel)
 Posli('open 0'); // otevreme cestujicimu blaznovi dvere
 end;
end;

procedure TForm1.btnDelMemoClick(Sender: TObject);
begin
memoUdalosti.Lines.Clear;
end;

procedure TForm1.btnNastavClick(Sender: TObject);
begin
 Posli('lipinfo '+ edtTextInfo.text);
end;

end.
